/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.138 Revision 1.164
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.138 2011/10/07 10:57:48 djc Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.164 2012/12/20 06:34:57 floppym Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Gentoo Python Project <python@gentoo.org> 7# Gentoo Python Project <python@gentoo.org>
8# @BLURB: Eclass for Python packages 8# @BLURB: Eclass for Python packages
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The python eclass contains miscellaneous, useful functions for Python packages. 10# The python eclass contains miscellaneous, useful functions for Python packages.
11 11
12if [[ ${_PYTHON_UTILS_R1} ]]; then
13 die 'python.eclass can not be used with python-r1 suite eclasses.'
14fi
15
16# Must call inherit before EXPORT_FUNCTIONS to avoid QA warning.
17if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
12inherit multilib 18 inherit multilib
19fi
13 20
21# Export pkg_setup every time to avoid issues with eclass inheritance order.
22if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
23 EXPORT_FUNCTIONS pkg_setup
24fi
25
26# Avoid processing this eclass more than once.
27if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
28_PYTHON_ECLASS_INHERITED="1"
29
14if ! has "${EAPI:-0}" 0 1 2 3; then 30if ! has "${EAPI:-0}" 0 1 2 3 4 5; then
15 die "API of python.eclass in EAPI=\"${EAPI}\" not established" 31 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16fi 32fi
17 33
18_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7) 34_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
19_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.1 3.2) 35_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.1 3.2 3.3)
20_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython) 36_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython)
21_PYPY_GLOBALLY_SUPPORTED_ABIS=(2.7-pypy-1.5) 37_PYPY_GLOBALLY_SUPPORTED_ABIS=(2.7-pypy-1.7 2.7-pypy-1.8 2.7-pypy-1.9 2.7-pypy-2.0)
22_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]} ${_PYPY_GLOBALLY_SUPPORTED_ABIS[@]}) 38_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]} ${_PYPY_GLOBALLY_SUPPORTED_ABIS[@]})
23 39
24# ================================================================================================ 40# ================================================================================================
25# ===================================== HANDLING OF METADATA ===================================== 41# ===================================== HANDLING OF METADATA =====================================
26# ================================================================================================ 42# ================================================================================================
86 102
87 return 1 103 return 1
88 fi 104 fi
89} 105}
90 106
107_python_implementation() {
108 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
109 return 0
110 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
111 return 0
112 elif [[ "${CATEGORY}/${PN}" == "dev-python/pypy" ]]; then
113 return 0
114 else
115 return 1
116 fi
117}
118
91_python_package_supporting_installation_for_multiple_python_abis() { 119_python_package_supporting_installation_for_multiple_python_abis() {
92 if has "${EAPI:-0}" 0 1 2 3 4; then
93 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 120 [[ -n "${SUPPORT_PYTHON_ABIS}" ]]
94 return 0
95 else
96 return 1
97 fi
98 else
99 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
100 fi
101} 121}
102 122
103# @ECLASS-VARIABLE: PYTHON_DEPEND 123# @ECLASS-VARIABLE: PYTHON_DEPEND
104# @DESCRIPTION: 124# @DESCRIPTION:
105# Specification of dependency on dev-lang/python. 125# Specification of dependency on dev-lang/python.
231 else 251 else
232 die "Invalid syntax of PYTHON_DEPEND" 252 die "Invalid syntax of PYTHON_DEPEND"
233 fi 253 fi
234} 254}
235 255
256if _python_implementation; then
236DEPEND=">=app-admin/eselect-python-20091230" 257 DEPEND=">=app-admin/eselect-python-20091230"
237RDEPEND="${DEPEND}" 258 RDEPEND="${DEPEND}"
259 PDEPEND="app-admin/python-updater"
260fi
238 261
239if [[ -n "${PYTHON_DEPEND}" ]]; then 262if [[ -n "${PYTHON_DEPEND}" ]]; then
240 _python_parse_PYTHON_DEPEND 263 _python_parse_PYTHON_DEPEND
241else 264else
242 _PYTHON_ATOMS=("dev-lang/python") 265 _PYTHON_ATOMS=("dev-lang/python")
281 _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}" 304 _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}"
282 fi 305 fi
283 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then 306 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then
284 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )" 307 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )"
285 fi 308 fi
286 DEPEND+=" ${_PYTHON_USE_WITH_ATOMS}" 309 DEPEND+="${DEPEND:+ }${_PYTHON_USE_WITH_ATOMS}"
287 RDEPEND+=" ${_PYTHON_USE_WITH_ATOMS}" 310 RDEPEND+="${RDEPEND:+ }${_PYTHON_USE_WITH_ATOMS}"
288 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY 311 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY
289fi 312fi
290 313
291unset _PYTHON_ATOMS 314unset _PYTHON_ATOMS
292 315
293# ================================================================================================ 316# ================================================================================================
294# =================================== MISCELLANEOUS FUNCTIONS ==================================== 317# =================================== MISCELLANEOUS FUNCTIONS ====================================
295# ================================================================================================ 318# ================================================================================================
296
297_python_implementation() {
298 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
299 return 0
300 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
301 return 0
302 elif [[ "${CATEGORY}/${PN}" == "dev-python/pypy" ]]; then
303 return 0
304 else
305 return 1
306 fi
307}
308 319
309_python_abi-specific_local_scope() { 320_python_abi-specific_local_scope() {
310 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]] 321 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]]
311} 322}
312 323
384 _CYAN= 395 _CYAN=
385 _NORMAL= 396 _NORMAL=
386 fi 397 fi
387} 398}
388 399
389unset PYTHON_PKG_SETUP_EXECUTED
390
391_python_check_python_pkg_setup_execution() { 400_python_check_python_pkg_setup_execution() {
392 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return 401 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return
393 402
394 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then 403 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then
395 die "python_pkg_setup() not called" 404 die "python_pkg_setup() not called"
463 fi 472 fi
464 473
465 PYTHON_PKG_SETUP_EXECUTED="1" 474 PYTHON_PKG_SETUP_EXECUTED="1"
466} 475}
467 476
468if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
469 EXPORT_FUNCTIONS pkg_setup
470fi
471
472_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|pypy-c|python)' 477_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|pypy-c|python)'
473 478
474# @FUNCTION: python_convert_shebangs 479# @FUNCTION: python_convert_shebangs
475# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories] 480# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories]
476# @DESCRIPTION: 481# @DESCRIPTION:
477# Convert shebangs in specified files. Directories can be specified only with --recursive option. 482# Convert shebangs in specified files. Directories can be specified only with --recursive option.
478python_convert_shebangs() { 483python_convert_shebangs() {
479 _python_check_python_pkg_setup_execution 484 _python_check_python_pkg_setup_execution
480 485
481 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" 486 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" shebangs_converted="0"
482 487
483 while (($#)); do 488 while (($#)); do
484 case "$1" in 489 case "$1" in
485 -r|--recursive) 490 -r|--recursive)
486 recursive="1" 491 recursive="1"
541 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue 546 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
542 547
543 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then 548 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then
544 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue 549 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
545 550
551 shebangs_converted="1"
552
546 if [[ "${quiet}" == "0" ]]; then 553 if [[ "${quiet}" == "0" ]]; then
547 einfo "Converting shebang in '${file}'" 554 einfo "Converting shebang in '${file}'"
548 fi 555 fi
549 556
550 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|pypy-c\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed" 557 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|pypy-c\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
551 fi 558 fi
559 done
560
561 if [[ "${shebangs_converted}" == "0" ]]; then
562 ewarn "${FUNCNAME}(): Python scripts not found"
563 fi
564}
565
566# @FUNCTION: python_clean_py-compile_files
567# @USAGE: [-q|--quiet]
568# @DESCRIPTION:
569# Clean py-compile files to disable byte-compilation.
570python_clean_py-compile_files() {
571 _python_check_python_pkg_setup_execution
572
573 local file files=() quiet="0"
574
575 while (($#)); do
576 case "$1" in
577 -q|--quiet)
578 quiet="1"
579 ;;
580 -*)
581 die "${FUNCNAME}(): Unrecognized option '$1'"
582 ;;
583 *)
584 die "${FUNCNAME}(): Invalid usage"
585 ;;
586 esac
587 shift
588 done
589
590 while read -d $'\0' -r file; do
591 files+=("${file#./}")
592 done < <(find -name py-compile -type f -print0)
593
594 for file in "${files[@]}"; do
595 if [[ "${quiet}" == "0" ]]; then
596 einfo "Cleaning '${file}' file"
597 fi
598 echo "#!/bin/sh" > "${file}"
552 done 599 done
553} 600}
554 601
555# @FUNCTION: python_clean_installation_image 602# @FUNCTION: python_clean_installation_image
556# @USAGE: [-q|--quiet] 603# @USAGE: [-q|--quiet]
699 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then 746 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then
700 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install 747 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install
701 fi 748 fi
702fi 749fi
703 750
704if has "${EAPI:-0}" 0 1 2 3 4; then
705 unset PYTHON_ABIS 751unset PYTHON_ABIS
706fi
707 752
708_python_calculate_PYTHON_ABIS() { 753_python_calculate_PYTHON_ABIS() {
709 if ! _python_package_supporting_installation_for_multiple_python_abis; then 754 if ! _python_package_supporting_installation_for_multiple_python_abis; then
710 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 755 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
711 fi 756 fi
712 757
713 _python_initial_sanity_checks 758 _python_initial_sanity_checks
714 759
715 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then 760 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]]; then
716 local PYTHON_ABI 761 local PYTHON_ABI
717 762
718 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then 763 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
719 local cpython_enabled="0" 764 local cpython_enabled="0"
720 765
794 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}" 839 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}"
795 fi 840 fi
796 else 841 else
797 python3_version="" 842 python3_version=""
798 fi 843 fi
844 fi
845
846 if [[ -z "${python2_version}" && -z "${python3_version}" ]]; then
847 eerror "${CATEGORY}/${PF} requires at least one of the following packages:"
848 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
849 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
850 eerror " dev-lang/python:${PYTHON_ABI}"
851 fi
852 done
853 die "No supported version of CPython installed"
799 fi 854 fi
800 855
801 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then 856 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then
802 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink" 857 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink"
803 eerror "is set incorrectly. Use \`eselect python\` to fix configuration." 858 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
961 python_default_function() { 1016 python_default_function() {
962 emake "$@" 1017 emake "$@"
963 } 1018 }
964 elif [[ "${EBUILD_PHASE}" == "test" ]]; then 1019 elif [[ "${EBUILD_PHASE}" == "test" ]]; then
965 python_default_function() { 1020 python_default_function() {
1021 # Stolen from portage's _eapi0_src_test()
1022 local emake_cmd="${MAKE:-make} ${MAKEOPTS} ${EXTRA_EMAKE}"
966 if emake -j1 -n check &> /dev/null; then 1023 if ${emake_cmd} -j1 -n check &> /dev/null; then
967 emake -j1 check "$@" 1024 ${emake_cmd} -j1 check "$@"
968 elif emake -j1 -n test &> /dev/null; then 1025 elif ${emake_cmd} -j1 -n test &> /dev/null; then
969 emake -j1 test "$@" 1026 ${emake_cmd} -j1 test "$@"
970 fi 1027 fi
971 } 1028 }
972 elif [[ "${EBUILD_PHASE}" == "install" ]]; then 1029 elif [[ "${EBUILD_PHASE}" == "install" ]]; then
973 python_default_function() { 1030 python_default_function() {
974 emake DESTDIR="${D}" install "$@" 1031 emake DESTDIR="${D}" install "$@"
1241pypy_interpreter_re = re.compile(r"^pypy-c(\d+\.\d+)$") 1298pypy_interpreter_re = re.compile(r"^pypy-c(\d+\.\d+)$")
1242cpython_shebang_re = re.compile(r"^#![ \t]*(?:${EPREFIX}/usr/bin/python|(?:${EPREFIX})?/usr/bin/env[ \t]+(?:${EPREFIX}/usr/bin/)?python)") 1299cpython_shebang_re = re.compile(r"^#![ \t]*(?:${EPREFIX}/usr/bin/python|(?:${EPREFIX})?/usr/bin/env[ \t]+(?:${EPREFIX}/usr/bin/)?python)")
1243python_shebang_options_re = re.compile(r"^#![ \t]*${EPREFIX}/usr/bin/(?:jython|pypy-c|python)(?:\d+(?:\.\d+)?)?[ \t]+(-\S)") 1300python_shebang_options_re = re.compile(r"^#![ \t]*${EPREFIX}/usr/bin/(?:jython|pypy-c|python)(?:\d+(?:\.\d+)?)?[ \t]+(-\S)")
1244python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$") 1301python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
1245 1302
1246pypy_versions_mapping = { 1303#pypy_versions_mapping = {
1247 "1.5": "2.7" 1304# "1.5": "2.7",
1248} 1305# "1.6": "2.7",
1306# "1.7": "2.7",
1307# "1.8": "2.7",
1308# "1.9": "2.7",
1309# "2.0": "2.7",
1310#}
1249 1311
1250def get_PYTHON_ABI(python_interpreter): 1312def get_PYTHON_ABI(python_interpreter):
1251 cpython_matched = cpython_interpreter_re.match(python_interpreter) 1313 cpython_matched = cpython_interpreter_re.match(python_interpreter)
1252 jython_matched = jython_interpreter_re.match(python_interpreter) 1314 jython_matched = jython_interpreter_re.match(python_interpreter)
1253 pypy_matched = pypy_interpreter_re.match(python_interpreter) 1315 pypy_matched = pypy_interpreter_re.match(python_interpreter)
1254 if cpython_matched is not None: 1316 if cpython_matched is not None:
1255 PYTHON_ABI = cpython_matched.group(1) 1317 PYTHON_ABI = cpython_matched.group(1)
1256 elif jython_matched is not None: 1318 elif jython_matched is not None:
1257 PYTHON_ABI = jython_matched.group(1) + "-jython" 1319 PYTHON_ABI = jython_matched.group(1) + "-jython"
1258 elif pypy_matched is not None: 1320 elif pypy_matched is not None:
1259 PYTHON_ABI = pypy_versions_mapping[pypy_matched.group(1)] + "-pypy-" + pypy_matched.group(1) 1321 #PYTHON_ABI = pypy_versions_mapping[pypy_matched.group(1)] + "-pypy-" + pypy_matched.group(1)
1322 PYTHON_ABI = "2.7-pypy-" + pypy_matched.group(1)
1260 else: 1323 else:
1261 PYTHON_ABI = None 1324 PYTHON_ABI = None
1262 return PYTHON_ABI 1325 return PYTHON_ABI
1263 1326
1264def get_python_interpreter(PYTHON_ABI): 1327def get_python_interpreter(PYTHON_ABI):
1592 fi 1655 fi
1593 done 1656 done
1594 1657
1595 popd > /dev/null || die "popd failed" 1658 popd > /dev/null || die "popd failed"
1596 1659
1660 # This is per bug #390691, without the duplication refactor, and with
1661 # the 3-way structure per comment #6. This enable users with old
1662 # coreutils to upgrade a lot easier (you need to upgrade python+portage
1663 # before coreutils can be upgraded).
1597 if ROOT="/" has_version sys-apps/coreutils; then 1664 if ROOT="/" has_version '>=sys-apps/coreutils-6.9.90'; then
1598 cp -fr --preserve=all --no-preserve=context "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed" 1665 cp -fr --preserve=all --no-preserve=context "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1666 elif ROOT="/" has_version sys-apps/coreutils; then
1667 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1599 else 1668 else
1600 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed" 1669 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1601 fi 1670 fi
1602 done 1671 done
1603 1672
2638 fi 2707 fi
2639 2708
2640 export PYTHONDONTWRITEBYTECODE="1" 2709 export PYTHONDONTWRITEBYTECODE="1"
2641} 2710}
2642 2711
2712_python_vecho() {
2713 [[ -z ${PORTAGE_VERBOSE} ]] || echo "$@"
2714}
2715
2643_python_clean_compiled_modules() { 2716_python_clean_compiled_modules() {
2644 _python_initialize_prefix_variables 2717 _python_initialize_prefix_variables
2645 _python_set_color_variables 2718 _python_set_color_variables
2646 2719
2647 [[ "${FUNCNAME[1]}" =~ ^(python_mod_optimize|python_mod_cleanup)$ ]] || die "${FUNCNAME}(): Invalid usage" 2720 [[ "${FUNCNAME[1]}" =~ ^(python_mod_optimize|python_mod_cleanup)$ ]] || die "${FUNCNAME}(): Invalid usage"
2660 2733
2661 if [[ "${EBUILD_PHASE}" == "postrm" ]]; then 2734 if [[ "${EBUILD_PHASE}" == "postrm" ]]; then
2662 # Delete empty child directories. 2735 # Delete empty child directories.
2663 find "${path}" -type d | sort -r | while read -r dir; do 2736 find "${path}" -type d | sort -r | while read -r dir; do
2664 if rmdir "${dir}" 2> /dev/null; then 2737 if rmdir "${dir}" 2> /dev/null; then
2665 echo "${_CYAN}<<< ${dir}${_NORMAL}" 2738 _python_vecho "<<< ${dir}"
2666 fi 2739 fi
2667 done 2740 done
2668 fi 2741 fi
2669 elif [[ "${path}" == *.py ]]; then 2742 elif [[ "${path}" == *.py ]]; then
2670 base_module_name="${path##*/}" 2743 base_module_name="${path##*/}"
2693 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then 2766 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2694 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue 2767 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2695 else 2768 else
2696 [[ -f "${py_file}" ]] && continue 2769 [[ -f "${py_file}" ]] && continue
2697 fi 2770 fi
2698 echo "${_BLUE}<<< ${compiled_file%[co]}[co]${_NORMAL}" 2771 _python_vecho "<<< ${compiled_file%[co]}[co]"
2699 rm -f "${compiled_file%[co]}"[co] 2772 rm -f "${compiled_file%[co]}"[co]
2700 elif [[ "${compiled_file}" == *\$py.class ]]; then 2773 elif [[ "${compiled_file}" == *\$py.class ]]; then
2701 if [[ "${dir}" == "__pycache__" ]]; then 2774 if [[ "${dir}" == "__pycache__" ]]; then
2702 base_module_name="${compiled_file##*/}" 2775 base_module_name="${compiled_file##*/}"
2703 base_module_name="${base_module_name%\$py.class}" 2776 base_module_name="${base_module_name%\$py.class}"
2708 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then 2781 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2709 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue 2782 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2710 else 2783 else
2711 [[ -f "${py_file}" ]] && continue 2784 [[ -f "${py_file}" ]] && continue
2712 fi 2785 fi
2713 echo "${_BLUE}<<< ${compiled_file}${_NORMAL}" 2786 _python_vecho "<<< ${compiled_file}"
2714 rm -f "${compiled_file}" 2787 rm -f "${compiled_file}"
2715 else 2788 else
2716 die "${FUNCNAME}(): Unrecognized file type: '${compiled_file}'" 2789 die "${FUNCNAME}(): Unrecognized file type: '${compiled_file}'"
2717 fi 2790 fi
2718 2791
2719 # Delete empty parent directories. 2792 # Delete empty parent directories.
2720 dir="${compiled_file%/*}" 2793 dir="${compiled_file%/*}"
2721 while [[ "${dir}" != "${root}" ]]; do 2794 while [[ "${dir}" != "${root}" ]]; do
2722 if rmdir "${dir}" 2> /dev/null; then 2795 if rmdir "${dir}" 2> /dev/null; then
2723 echo "${_CYAN}<<< ${dir}${_NORMAL}" 2796 _python_vecho "<<< ${dir}"
2724 else 2797 else
2725 break 2798 break
2726 fi 2799 fi
2727 dir="${dir%/*}" 2800 dir="${dir%/*}"
2728 done 2801 done
3108} 3181}
3109 3182
3110# ================================================================================================ 3183# ================================================================================================
3111# ===================================== DEPRECATED FUNCTIONS ===================================== 3184# ===================================== DEPRECATED FUNCTIONS =====================================
3112# ================================================================================================ 3185# ================================================================================================
3186
3187fi # _PYTHON_ECLASS_INHERITED

Legend:
Removed from v.1.138  
changed lines
  Added in v.1.164

  ViewVC Help
Powered by ViewVC 1.1.20